function [] = demo_kMeans(fname)
% demos kMeans on dataset stored in fname

col = 'rbgckm'; 
feval('load',fname);
n = size(data,1); 
figure; 
for i=1:4
%%%%%%%%%%%%%%%%%%
subplot(2,2,i);
plot(data(:,1),data(:,2),'k.'); 
hold on; 
axis tight; 
a = axis; 
axis(a+[-0.05 0.05 -0.05 0.05]);  

% Initialize centers from user
% Press middle or right mouse button to stop 

title('Click to initialize cluster centers'); 

clear centers; 
BUTTON = 1; 
k = 1; 
while BUTTON==1
   [A,B,BUTTON] = ginput(1); 
   if BUTTON==1
     centers(k,1:2) = [A B];    
     plot(centers(k,1),centers(k,2),[col(k),'o']); 
     plot(centers(k,1),centers(k,2),[col(k),'x']); 
     title(['Number of clusters initialized: {\bf ',num2str(k),'}']); 
     k = k + 1; 
   end; 
end; 

K = size(centers,1);
   
flag=1; 
itn = 1; 
D = dist2(data, centers(:,:,itn));    
J(itn) = sum(min(D,[],2)); 

while flag==1
   title(['Iteration: {\bf ',num2str(itn),...
		'} (DATA \rightarrow CLUSTERS) Cost: {\bf ',num2str(J(itn)),'}']); 

   for k=1:K
      inx = find(min(D,[],2)==D(:,k));  
         plot(centers(k,1,itn),centers(k,2,itn),[col(k),'o']); 
      if length(inx)>0
         plot(data(inx,1),data(inx,2),[col(k),'.']);
         centers(k,:,itn+1) = mean(data(inx,:),1); 
      else 
         centers(k,:,itn+1) = centers(k,:,itn);
      end; 
   end; 

   ginput(1);

   itn = itn + 1; 

   title(['Iteration: {\bf ',num2str(itn),'} (CLUSTER CENTERS \rightarrow DATA MEAN)']);    

   for k=1:K
      plot(centers(k,1,itn-1),centers(k,2,itn-1),'wo'); 
      plot(centers(k,1,itn-1),centers(k,2,itn-1),[col(k),'x']); 
      
      plot(centers(k,1,itn),centers(k,2,itn),[col(k),'o']); 
      plot(centers(k,1,itn),centers(k,2,itn),[col(k),'x']);
      h = line([centers(k,1,itn) centers(k,1,itn-1)],...
	 [centers(k,2,itn) centers(k,2,itn-1)]);
      set(h,'Color',col(k)); 
   end; 

   ginput(1); 

   D = dist2(data, centers(:,:,itn));    
   J(itn) = sum(min(D,[],2)); 
   if J(itn-1)-J(itn)<0.01, flag=0; end; 
end; 

title(['{\bf FINAL CLUSTERS: Cost = ',num2str(J(itn)),'}']); 
for k=1:K
  inx = find(min(D,[],2)==D(:,k)); 
  plot(data(inx,1),data(inx,2),[col(k),'.']); 
  plot(centers(k,1,itn),centers(k,2,itn),[col(k),'x']);
  plot(centers(k,1,itn),centers(k,2,itn),[col(k),'o']); 
end; 
%%%%%%%%%%%%%%%
ginput(1);
end; 









