function [] = demoMinClust(fname,maxK)
%

feval('load',fname);
plot(data(:,1),data(:,2),'ro'); 
axis tight; 
a = axis; 
axis(a+[-0.05 0.05 -0.05 0.05]); 
hold; 
axis off; 
n = size(data,1); 
% Initially each point is a cluster
for i=1:n
   inx{i} = i; 
   A(i) = 1; 
end; 
nclust = n; 
t = title(['{\it Nearest Neighbor Clustering}: {\bf ',num2str(nclust),'}']); 
set(t,'FontSize',15');

flag=0; 

while nclust>2
  clear D; 
  I = find(A==1); 
  % Compute distance between all pairs of clusters
  for i=1:length(I)-1
    for j=i+1:length(I)
      D(i,j) = minDist(data, inx{I(i)}, inx{I(j)}); 
      D(j,i) = D(i,j); 
    end; 
    D(i,i) = Inf; 
  end; 
  i=i+1; 
  D(i,i) = Inf; 

  if nclust==maxK
    flag=0; 
  end; 

  % Find indices of closest clusters
  [p,q] = min(D); 
  [r,s] = min(p); 
  mrg = sort([s q(s)]);
  nclust = nclust-1; 
  [i1,i2] = findClosestPoints(data,inx{I(mrg(1))}, inx{I(mrg(2))}); 
  line([data(i1,1) data(i2,1)], [data(i1,2) data(i2,2)]); 
  title(['{\it Nearest Neighbor Clustering}: {\bf ',num2str(nclust),'}']); 
  set(t,'FontSize',15');

  inx{I(mrg(1))} = [inx{I(mrg(1))} inx{I(mrg(2))}]; 
  A(I(mrg(2))) = 0; 
  inx{I(mrg(2))} = []; 

  if flag==0
     [x,y,b] = ginput(1);
     if b>1, flag=1; end; 
  else
     if n<30, pause(1); else, if nclust>30, pause(1/nclust); else pause(1); end; end; 
  end; 
end; 

ginput(1);








